-- Slide 15:

SELECT no, MAX(kid)
FROM cages LEFT JOIN keeps 
ON no=cageno
GROUP BY no

-- Slide 16

SELECT no, COUNT(*)
FROM cages LEFT JOIN keeps 
ON no=cageno
GROUP BY no


--Slide 17

SELECT no, COUNT(cageno)
FROM cages LEFT JOIN keeps 
ON no=cageno
GROUP BY no


-- Slide 19
SELECT bear_keepers.name
FROM keepers AS bear_keepers 
JOIN keeps AS bear_keeps ON bear_keepers.id = bear_keeps.kid
JOIN cages AS bear_cages ON bear_keeps.cageno = bear_cages.no
JOIN animals AS bear_animals ON bear_animals.acageno = bear_cages.no
JOIN keepers AS giraffe_keepers 
JOIN keeps AS giraffe_keeps ON giraffe_keepers.id = giraffe_keeps.kid
JOIN cages AS giraffe_cages ON giraffe_keeps.cageno = giraffe_cages.no
JOIN animals AS giraffe_animals ON giraffe_animals.acageno = giraffe_cages.no
WHERE bear_animals.species = 'Bear'
AND giraffe_animals.species = 'Giraffe'
AND giraffe_keepers.id = bear_keepers.id


--Slide 24

SELECT bear_keepers.name
FROM (
    SELECT id, keepers.name FROM
    keepers JOIN keeps ON id = kid
    JOIN cages ON cageno = no
    JOIN animals ON acageno = no
    WHERE species = 'Bear'
) AS bear_keepers
JOIN (
    SELECT id, keepers.name FROM
    keepers JOIN keeps ON id = kid
    JOIN cages ON cageno = no
    JOIN animals ON acageno = no
    WHERE species = 'Giraffe'
) AS giraffe_keepers 
ON giraffe_keepers.id = bear_keepers.id


--Slide 25

WITH bear_keepers AS (
    SELECT id, keepers.name FROM
    keepers JOIN keeps ON id = kid
    JOIN cages ON cageno = no
    JOIN animals ON acageno = no
    WHERE species = 'Bear'
),
giraffe_keepers AS (
    SELECT id, keepers.name FROM
    keepers JOIN keeps ON id = kid
    JOIN cages ON cageno = no
    JOIN animals ON acageno = no
    WHERE species = 'Giraffe'
) 
SELECT bear_keepers.name
FROM bear_keepers JOIN giraffe_keepers
ON giraffe_keepers.id = bear_keepers.id




--Slide 28

WITH giraffe_keepers AS (
    SELECT id 
    FROM keepers JOIN keeps ON id = kid
    JOIN cages ON cageno = no
    JOIN animals ON acageno = no
    WHERE species = 'Giraffe'
), giraffe_keeper_cages AS (
    SELECT cageno FROM
    giraffe_keepers JOIN keeps ON kid = id
)
SELECT name,species 
FROM animals JOIN giraffe_keeper_cages ON cageno = acageno
WHERE species != 'Giraffe'

-- Slide 33

WITH giraffe_keepers AS (
    SELECT id 
    FROM keepers JOIN keeps ON id = kid
    JOIN cages ON cageno = no
    JOIN animals ON acageno = no
    WHERE species = 'Giraffe'
), giraffe_keeper_cages AS (
    SELECT cageno FROM
    giraffe_keepers JOIN keeps ON kid = id
)
SELECT DISTINCT name,species 
FROM animals JOIN giraffe_keeper_cages ON cageno = acageno
WHERE species != 'Giraffe'

-- Slide 35

WITH RECURSIVE t(n) AS 
( VALUES (1) 
UNION
SELECT n+1 
FROM t WHERE n < 100 
) 
SELECT sum(n) FROM t; 



-- Slide 37

WITH RECURSIVE
  xaxis(x) AS (VALUES(-2.0) UNION ALL SELECT x+0.05 FROM xaxis WHERE x<1.2),
  yaxis(y) AS (VALUES(-1.0) UNION ALL SELECT y+0.1 FROM yaxis WHERE y<1.0),
  m(iter, cx, cy, x, y) AS (
    SELECT 0, x, y, 0.0, 0.0 FROM xaxis, yaxis
    UNION ALL
    SELECT iter+1, cx, cy, x*x-y*y + cx, 2.0*x*y + cy FROM m 
     WHERE (x*x + y*y) < 4.0 AND iter<28
  ),
  m2(iter, cx, cy) AS (
    SELECT max(iter), cx, cy FROM m GROUP BY cx, cy
  ),
  a(t) AS (
    SELECT group_concat( substr(' .+*#', 1+min(iter/7,4), 1), '') 
    FROM m2 GROUP BY cy
  )
SELECT group_concat(rtrim(t),x'0a') FROM a;


--slide 38

WITH recursive sick_keepers as (
    SELECT kid as sick_id  -- keepers who keep an animal who is sick
    FROM keeps
    JOIN animals on acageno = cageno
    WHERE animals.aname = 'Mike'
UNION
    SELECT k1.kid  -- keepers who keep the same cage as another keeper who might be sick
    FROM keeps k1
    JOIN keeps k2 on k2.cageno = k1.cageno
    JOIN sick_keepers on k2.kid = sick_id
)
SELECT distinct(aname) FROM animals -- animals in cages with keepers who might be sick
JOIN keeps on cageno = acageno
JOIN sick_keepers ON sick_id = kid






--slide 49
drop table times;

create table times (hour int, minute int, animalid int);
INSERT INTO times
  WITH RECURSIVE
    cte(x,y,z) AS (
       SELECT abs(random())%24,abs(random())%60,abs(random())%10
       UNION ALL
       SELECT abs(random())%24,abs(random())%60,abs(random())%10
         FROM cte
        LIMIT 1000
  )
SELECT x,y,z FROM cte;


--slide 49

SELECT hour, minute,
  (SELECT count(*)
   FROM times t2
   WHERE (t.hour = t2.hour
          AND t.minute >= t2.minute)
     OR (t.hour > t2.hour))
FROM times t
ORDER BY hour,
         minute;




--slide 50
select hour, minute, rank() over (order by  hour, minute) from times;
select hour, minute, cume_dist() over (order by  hour, minute) from times;

--slide 51

SELECT animalid,
       hour,
       minute,
       rank() over (partition BY animalid
                         ORDER BY hour, minute)
FROM times;

--slide 53

-- sqlite> select * from test;
-- 4|30|10
-- 1|15|20
-- 2|0|30
-- 3|10|40

SELECT hour, min, cume_dist() 
OVER (ORDER BY hour, min) as c FROM test

SELECT hour, min, qty, lag(qty,1) 
OVER (ORDER BY hour, min) as lag FROM times

SELECT hour, min, avg(qty) 
OVER (ORDER BY hour, min 
ROWS BETWEEN 2 PRECEDING AND CURRENT ROW) AS rolling_avg FROM times

--slide 55

-- sqlite> select * from sales;
-- 1/1/2022|5540.0
-- 1/2/2022|5042.0
-- 1/3/2022|3221.0
-- 1/4/2022|32312.0
-- 1/5/2022|4231.0
-- 1/6/2022|32132.0
-- 1/7/2022|3542.0
-- 1/8/2022|7000.0
-- 1/9/2022|3213.0

SELECT date, sales, sales - lag(sales,7) 
OVER (ORDER BY date) difference FROM sales



